#!/usr/bin/perl
###
### Configuration Variables
###

$Tax = 0.00;

# @referrers allows forms to be located only on servers 
# which are defined in this field. Edit this by replacing 
# "yourdomain" with your domain's name and "xxx.xxx.xxx.xxx"
# with your domain's numeric address
# @referrers = ('www.yourdomain.com','xxx.xxx.xxx.xxx');

### the message must get its body from a file; complete
### path to this temporary file must be supplied 
### $cl_ad_tmp = "cl_ad_proc.html";

###
### Main body of script
###

# seed the random number generator
srand();

# Check Referring URL
&check_url;

# parse the form data
&ReadParse;

# any required data? if so, has user supplied it?
if ( $in{'.required_data'} && &missing_data  ) {
    print &incomplete_page;
    exit;
}

## do you want the environment variables?
if ( $in{'.environment'} ) { 
    $message .= "\nThe environment variables are:\n\n";
    foreach (keys %ENV) {
        $message .= "\t$_: $ENV{$_}\n";
    }
  } else {
    ## let's at least report a few
    $message .= "\nReferring page: $ENV{HTTP_REFERRER}";
    $message .= "\nUser address: $ENV{REMOTE_ADDR}";
    $message .= "\nUser host: $ENV{REMOTE_HOST}";
  }


# create a customer ID
$Cust_id = &get_cust_num;
$Cust_id .= "$State";

# build a desciption of the order
# $Describe = "Classified Ad(s)";

# Regenerate page with user's input and calculated/hidden values
print &regen_page;

###
### End of main body of script.
### Subroutines below.
###

###
### Get customer number, then increment by one and save
###
sub get_cust_num {
    open (FH, "invnum.txt");
    $c_num = <FH>;
    close (FH);
    $next_num = $c_num + 1;
    open (FH, ">invnum.txt");
    print FH $next_num;
    close(FH);
    return $c_num;
}

###
### Return an array of missing fields among the Company data, or undef
### Need to name the fields descriptively so users will know what 
### form data they are missing.
###
sub missing_data {
    local ($result) = 0;
    foreach ( split (/::/, $in{'.required_data'} ) ) {
        unless ($in{$_}) {
            s/^..// if $in{'.remove_indexing'};
            push (@missing_fields, $_);
            $result = 1;
        }
    }
    return $result;
}

###
### Return the html source for an incomplete submission page
###
sub incomplete_page {
    local ($page_source) = <<"FIRST_HALF";
Content-type: text/html\n\n
<TITLE>Thanks, but oops ...</TITLE>
<H2>Thanks, but oops ...</H2>
Your information is important to us, and the following items
on the form were not filled in:
<UL>
FIRST_HALF

    foreach ( @missing_fields ) {
        $page_source .= "<LI>$_\n";
    }

    $page_source .= <<"SECOND_HALF";
</UL>
Please click your <STRONG>BACK</STRONG> button to return to the form
and add that information. Your other answers should still be there.
SECOND_HALF

    return $page_source;
}
   
sub check_url {

    # Localize the check_referrer flag which determines if user is valid.     #
    local($check_referrer) = 0;

    # If a referring URL was specified, for each valid referrer, make sure    #
    # that a valid referring URL was passed to FormMail.                     #

    if ($ENV{'HTTP_REFERRER'}) {
        foreach $referrer (@referrers) {
            if ($ENV{'HTTP_REFERRER'} =~ m|https?://([^/]*)$referrer|i) {
                $check_referrer = 1;
                last;
            }
        }
    }
    else {
        $check_referrer = 1;
    }

    # If the HTTP_REFERRER was invalid, send back an error.                   #
    if ($check_referrer != 1) { &error('bad_referrer'); }
}

### Note: this code is based on an older version of Stephen Brenner's  
### ReadParse. It is shown for illustration only. I suggest using the
### newer version included in his cgi-lib.plm included with this book.

sub ReadParse {
    local (*in) = @_ if @_;
    local ($i, $key, $val);

    if ( $ENV{'REQUEST_METHOD'} eq "GET" ) { # replaced his MethGet function
        ## don't accept GET, to make it a little harder to spoof the script
        print "Content-type: text/html\n\n";
	print "Sorry, this script only accepts METHOD=POST. ";
	print "Use that inside your &lt;FORM ...&gt; tag";
	exit;
    } 
    elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
        read(STDIN,$in,$ENV{'CONTENT_LENGTH'});
    } 
    else {
        # Added for command line debugging
        # Supply name/value form data as a command line argument
        # Format: name1=value1\&name2=value2\&... (need to escape & for shell)
        # Find the first argument that's not a switch (-)
        $in = ( grep( !/^-/, @ARGV )) [0];
        $in =~ s/\\&/&/g;        
    }
    @in = split(/&/,$in);

    foreach $i (0 .. $#in) {
        # Convert plus's to spaces
        $in[$i] =~ s/\+/ /g;

        # Split into key and value.
        ($key, $val) = split(/=/,$in[$i],2); # splits on the first =.

        # Convert %XX from hex numbers to alphanumeric
        $key =~ s/%(..)/pack("c",hex($1))/ge;       
        $val =~ s/%(..)/pack("c",hex($1))/ge;

	if ($key eq "Quantity1") {
	    $Quantity1 = $val;
	    $Quantity1 =~ s/;.*//;
	    $Quantity1 =~ s/,.*//;
	    $Quantity1 =~ tr/0-9/\b/cs;
	}
	if ($key eq "Name1") {
	    $Name1 = $val;
	    $Name1 =~ s/;.*//;
            $Name1 =~ s/,.*//;
            $Name1 =~ tr/[A-Z][a-z]/\b/cs;
	}
	if ($key eq "Name2") {
	    $Name2 = $val;
	    $Name2 =~ s/;.*//;
            $Name2 =~ s/,.*//;
            $Name2 =~ tr/[A-Z][a-z]/\b/cs;
	}
	if ($key eq "Email") {
	    $Email = $val;
	    $Email =~ s/;.*//;
	    $Email =~ s/,.*//;
	    if ($Email !~ 
		/^[\w\d][\w\d\,\.\-]*\@([\w\d\-]+\.)+([a-zA-Z]{3}|[a-zA-Z]{2})$/) {
		$Email = "";
	    }
	}
	if ($key eq "Phone") {
	    $Phone = $val;
            $Phone =~ tr/\(\)\-[0-9]/\b/cs;
	}
	if ($key eq "Address") {
	    $Address = $val;
	    $Address =~ s/;.*//;
	    $Address =~ s/,.*//;
	    $Address =~ tr/[A-Z][a-z][0-9]\t \./\b/cs;
	}
	if ($key eq "City") {
	    $City = $val;
            $City =~ s/;.*//;
            $City =~ s/,.*//;
            $City =~ tr/[A-Z][a-z]/\b/cs;
	}
	if ($key eq "State") {
	    $State = $val;
            $State =~ s/;.*//;
            $State =~ s/,.*//;
            $State =~ tr/[A-Z][a-z]/\b/cs;
	}
	if ($key eq "Zipcode") {
	    $Zipcode = $val;
            $Zipcode =~ s/;.*//;
            $Zipcode =~ s/,.*//;
            $Zipcode =~ tr/[0-9]\-/\b/cs;
	}
	if ($key eq "Country") {
	    $Country = $val;
	    $Country =~ s/;.*//;
	    $Country =~ s/,.*//;
	    $Country =~ tr/[A-Z][a-z]/\b/cs;
	}
	if ($key eq "Company") {
	    $Company = $val;
	}
	if ($key eq "Fax") {
	    $Fax = $val;
            $Fax =~ tr/\(\)\-[0-9]/\b/cs;
	}
	if ($key eq "Adtype") {
	    $Adtype = $val;
	    if ($Adtype eq "Regular") {
		$Describe = "Classified Ad(s)";
		$Unit_Price = 5.00;
	    }
	    if ($Adtype eq "Sponsor") {
                $Describe = "Top Sponsor Ad(s)";
		$Unit_Price = 10.00;
	    }
	    if ($Adtype eq "Solo") {
                $Describe = "Solo Ad(s)";
		$Unit_Price = 15.00;
	    }
	}
	$Subtotal = $Quantity1 * $Unit_Price;
	$Total    = $Subtotal;
	if ($Subtotal !~ /\./) {
	    $Subtotal .=".00";
	}
	if ($Subtotal !~/\.[0-9][0-9]/) {
	    $Subtotal .="0";
	}
	if ($Tax !~ /\./) {
	    $Tax .=".00";
	}
	if ($Tax !~/\.[0-9][0-9]/) {
	    $Tax .="0";
	}
	if ($Total !~ /\./) {
	    $Total .=".00";
	}
	if ($Total !~/\.[0-9][0-9]/) {
	    $Total .="0";
	}

        # Associate key and value
        # \0 is the multiple separator
        $in{$key} .= "\0" if (defined($in{$key})); 
        $in{$key} .= $val;
    }

    return length($in);
}

###
### Generate the new page based on input data
###  
sub regen_page {
    local ($page_source) = <<"END";
Content-type: text/html\n\n
<html>
<head>
<META http-equiv="Content-Type" content="text/html; charset=IS0-8859-1">
<title>Classified Ad -- Order Page </title>
</head>
<body BGCOLOR="#FFFFCC" TEXT="#000000" VLINK="#FF0000" ALINK="#FFFFFF">
<div align="center"><center>
<table border="0" width="600" cellspacing="0" cellpadding="0">
  <tr><td><HR></td></tr>
</table>
</center></div><div align="center"><center>
<table border="0" width="600" cellspacing="0" cellpadding="0">
  <tr>
    <td width="100%" align="center" height="30" valign="bottom">
    <strong><font color="#000080" face="Arial" size="3">
    Order Your Classified Ad(s) through our </font>
    <font face="Arial" color="#FF0000">Secure Server.</font></strong>
    </td>
  </tr>
</table>
</center></div><div align="center"><center>
<table border="0" width="600" cellspacing="0" cellpadding="0">
  <tr>
    <td width="596">
    <FORM method="POST" action="https://secure.quickcommerce.net/gateway/transact.dll">
      <INPUT type="hidden" name="x_Version" value="3.0">
      <INPUT type="hidden" name="x_Login" value="XXXXXXX">
      <INPUT type="hidden" name="x_Show_Form" value="PAYMENT_FORM">
      <INPUT type="hidden" name="x_Amount" value="$Total" maxlength="8">
      <INPUT type="hidden" name="x_Cust_ID" value="$Cust_id" maxlength="20">
      <input type="hidden" name="x_Description" value="$Describe">
      <INPUT type="hidden" name="x_First_Name" value="$Name1" maxlength="15">
      <INPUT type="hidden" name="x_Last_Name" value="$Name2" maxlength="20">
      <INPUT type="hidden" name="x_Address" value="$Address" maxlength="60">
      <INPUT type="hidden" name="x_City" value="$City" maxlength="40">
      <INPUT type="hidden" name="x_State" value="$State" maxlength="20">
      <INPUT type="hidden" name="x_Zip" value="$Zipcode" maxlength="10">
      <INPUT type="hidden" name="x_Country" value="$Country" maxlength="60">
      <INPUT type="hidden" name="x_Phone" value="$Phone" maxlength="20">
      <INPUT type="hidden" name="x_Company" value="$Company" maxlength="60">
      <INPUT type="hidden" name="x_Fax" value="$Fax" maxlength="20">
      <INPUT type="hidden" name="x_Email" value="$Email" maxlength="48">
      <INPUT type="hidden" name="x_Method" value="CC">
      <INPUT type="hidden" name="x_Email_Customer" value="TRUE">
      <INPUT type="hidden" name="x_Email_Merchant" value="TRUE">
      <INPUT type="hidden" name="x_Receipt_Link_Method" value="LINK">
      <INPUT type="hidden" name="x_Receipt_Link_Url" 
             value="http://www.yourdomain.com/order.html">
       <table border="0" width="100%">
        <tr>
          <td width="250" colspan="2"><strong><big>
          <font face="Arial" color="#0000FF">Order Information:</font>
          </big></strong></td>
        </tr>
        <tr>
          <td width="250"><strong><big><font face="Arial">Customer ID: </font>
          </big></strong></td>
          <td width="350"><strong><big><font face="Arial">$Cust_id</font>
          </big></strong></td>
        </tr>
        <tr>
          <td width="250"><strong><big><font face="Arial">Quantity: </font>
          </big></strong></td>
          <td width="350"><strong><big><font face="Arial">$Quantity1</font>
          </big></strong></td>
        </tr>
        <tr>
          <td width="250"><strong><big><font face="Arial">Description: </font>
          </big></strong></td>
          <td width="350"><strong><big><font face="Arial">$Describe</font>
          </big></strong></td>
        </tr>
        <tr>
          <td width="250"><strong><big><font face="Arial">First Name: </font>
          </big></strong></td>
          <td width="350"><strong><big><font face="Arial">$Name1</font>
          </big></strong></td>
        </tr>
        <tr>
          <td width="250"><strong><big><font face="Arial">Last Name: </font>
          </big></strong></td>
          <td width="350"><strong><big><font face="Arial">$Name2</font>
          </big></strong></td>
        </tr>
        <tr>
          <td width="250"><strong><big><font face="Arial">Company: </font>
          </td>
          <td width="350"><strong><big><font face="Arial">$Company</font><br>
          </td>
        </tr>
        <tr>
          <td width="250"><strong><big><font face="Arial">Email: </font>
          </big></strong></td>
          <td width="350"><strong><big><font face="Arial">$Email</font>
          </big></strong></td>
        </tr>
        <tr>
          <td width="250"><strong><big><font face="Arial">Phone: </font>
          </big></strong></td>
          <td width="350"><strong><big><font face="Arial">$Phone</font>
          </big></strong></td>
        </tr>
        <tr>
          <td width="250"><strong><big><font face="Arial">Fax: </font>
          </td>
          <td width="350"><strong><big><font face="Arial">$Fax</font><br>
          </td>
        </tr>
        <tr>
          <td width="250"><strong><big><font face="Arial">Total: </font>
          </big></strong></td>
          <td width="350"><strong><big><font face="Arial">\$$Total</font>
          </big></strong></td>
        </tr>
        <tr>
          <td width="250" colspan="2"><strong><big>
          <font face="Arial" color="#0000FF">Address Information:</font>
          </big></strong></td>
         </tr>
        <tr>
          <td width="250"><big><strong><font face="Arial">Address: </font>
          </big></strong></td>
          <td width="350"><strong><big><font face="Arial">$Address</font>
          </big></strong></td>
        </tr>
        <tr>
          <td width="250"><strong><big><font face="Arial">City: </font>
          </big></strong></td>
          <td width="350"><strong><big><font face="Arial">$City</font>
          </big></strong></td>
        </tr>
        <tr>
          <td width="250"><strong><big><font face="Arial">State/Province: </font>
          </td>
          <td width="350"><strong><big><font face="Arial">$State</font>
          </td>
        </tr>
        <tr>
          <td width="250"><strong><big><font face="Arial">Zipcode: </font>
          </td>
          <td width="350"><strong><big><font face="Arial">$Zipcode</font>
          </td>
        </tr>
        <tr>
          <td width="250"><strong><big><font face="Arial">Country: </font>
          </td>
          <td width="350"><strong><big><font face="Arial">$Country</font><br>
          </td>
        <tr>
          <td valign="top" width="250"><strong><big>
          <font face="Arial">Ad Type: </font>
          </td>
          <td width="600"><strong><big><font face="Arial">$Adtype</font>
          </td>
        </tr>
      </table>
      <div align="center">
      <center><table border="0" width="100%">
        <tr><td><HR></td></tr>
        <tr>
          <td><p><STRONG>PLEASE:</STRONG> Look this information over carefully and be 
          sure everything is correct. If you find any errors, please click your 
          <STRONG>BACK</STRONG>  button to return to the form and correct them. Your 
          other answers will still be visible. 
          </p></td>
        </tr>
	<tr><td><HR></td></tr>
        <tr>
          <td width="100%" height="50"><div align="center"><center><p>
          <input type="submit" value="Click Here for Secure Payment Form"></p>
          </center></div><div align="center"><center></td>
        </tr>
      </table>
      </center></div>
    </FORM>
    </td>
  </tr>
</table>
</center></div>
</body>
</html>
END

    return $page_source;
}


sub error
{
print S "QUIT\n"; 
print "Content-type: text/html\n";

print "\n";
print <<EOF;
<body bgcolor="#ffffff" text="#000000">
<font color=red>
The following error took place:
</font>
<p>
<b>$_[0]</b>
<p>
Click
 <a href="$ENV{HTTP_REFERRER}">here</a> to return.
<p>
OR, click on your browser's back button to restore your data. 
Correct any mistakes, then submit again.
EOF
exit(0);

}
